program BDDmpNam;
{$APPTYPE CONSOLE}
uses
  BorDebug;
var
  Handle: TBorDebHandle;
  NameBuf: array[0..1024] of char;
  NameCount : integer;
  i: integer;
  BorDebError: TBorDebError;
begin
  Handle := BorDebugRegisterFile(PChar(ParamStr(1)), false, true, BorDebError);
  if BorDebError <> deOk then Halt;
  NameCount := BorDebugNamesTotalNames(Handle);
  writeln('Total names: ', NameCount);
  for i := 1 to NameCount do  // Note: Name index is 1-based!
  begin
    BorDebugNameIndexToName(Handle, i, NameBuf, SizeOf(NameBuf));
    Writeln(i, ' = ', NameBuf);
  end;
  BorDebugUnregisterFile(Handle);
end.
